## certificate-transparency 20131206.1

=== doc/Makefile ===
VERSION=01
PREV=00
XML=rfc6962-bis.xml
NAME=draft-laurie-rfc6962-bis
BASE=$(NAME)-$(VERSION)
DIFF=$(NAME)-$(PREV)-$(VERSION)-diff.html

all: $(BASE).html $(BASE).txt $(DIFF)

.DELETE_ON_ERROR:

$(BASE).html: $(XML)
	xml2rfc --html -o $(BASE).html $(XML)

$(BASE).txt: $(XML)
	xml2rfc --text -o $(BASE).txt $(XML)

$(DIFF): $(NAME)-$(PREV).txt $(BASE).txt
	rfcdiff --stdout $(NAME)-$(PREV).txt $(BASE).txt > $(DIFF)

=== src/Makefile ===
CXXFLAG = -Wall -Werror -g -O3

# FIXME(benl): This breaks other installs and should be set locally if
# needed. It is not _technically_ their bug, it is _actually_ their
# bug. Commented out for now (as I can't build with it set).

# sometimes needed for certain libcurlpp-dev installs; technically their bug.
#CXXFLAG += -DHAVE_CONFIG_H

INCLUDE = -I.
LOCAL_LIBS = log/libcert.a log/libdatabase.a log/liblog.a \
             merkletree/libmerkletree.a proto/libproto.a util/libutil.a
SYS_LIBS = -lpthread -lgflags -lglog -lssl -lcrypto \
           -lsqlite3 -lprotobuf -lcurlpp -lcurl -lcppnetlib-uri

PLATFORM = $(shell uname -s)
ifneq ($(PLATFORM), FreeBSD)
  SYS_LIBS += -lresolv
endif

ifeq ($(PLATFORM), Darwin)
  SYS_LIBS += -lboost_system-mt
else
  SYS_LIBS += -lboost_system
endif

# Need OpenSSL >= 1.0.0
ifneq ($(OPENSSLDIR),)
  INCLUDE += -I $(OPENSSLDIR)/include
  SYS_LIBS += -L $(OPENSSLDIR) -L $(OPENSSLDIR)/lib -Wl,-rpath,$(OPENSSLDIR) \
          -Wl,-rpath,$(OPENSSLDIR)/lib
endif

# Need cpp-netlib
ifneq ($(CPPNETLIBDIR),)
  INCLUDE += -I $(CPPNETLIBDIR)
  SYS_LIBS += -L $(CPPNETLIBDIR)/libs/network/src \
              -Wl,-rpath,$(CPPNETLIBDIR)/libs/network/src
endif

# Json library location explicitly specified - link against that.
ifneq ($(JSONCLIBDIR),)
	INCLUDE += -I $(JSONCLIBDIR)/include
	SYS_LIBS += -L $(JSONCLIBDIR)/lib -Wl,-rpath,$(JSONCLIBDIR)/lib -ljson-c
else
	SYS_LIBS += -ljson
endif

# Need gtest
GTESTDIR ?= /usr/src/gtest
INCLUDE += -I $(GTESTDIR)/include

# Allow user-system overrides
INCLUDE += -I /usr/local/include
SYS_LIBS += -L /usr/local/lib

CXXFLAGS = $(INCLUDE) $(CXXFLAG) $(LOCAL_CXXFLAGS)

# File lists to simplify the rest of the Makefile

PROTO_TESTS = proto/serializer_test
MERKLETREE_TESTS = merkletree/merkle_tree_test \
                   merkletree/merkle_tree_large_test \
                   merkletree/serial_hasher_test merkletree/tree_hasher_test
LOG_TESTS = log/cert_test log/cert_checker_test \
            log/cert_submission_handler_test log/database_test \
            log/database_large_test log/file_storage_test \
            log/frontend_signer_test log/frontend_test log/log_lookup_test \
            log/signer_verifier_test log/log_signer_test log/tree_signer_test \
            log/logged_certificate_test log/ct_extensions_test
UTIL_TESTS = util/json_wrapper_test
ALL_TESTS = $(PROTO_TESTS) $(MERKLETREE_TESTS) $(LOG_TESTS) $(UTIL_TESTS)

all: unit_tests client/ct server/ct-server server/blob-server \
     server/ct-rfc-server

.DELETE_ON_ERROR:
.PHONY: clean all unit_tests test alltests benchmark clean \
        proto_tests merkletree_tests log_tests client_tests

gtest/Makefile: $(GTESTDIR)
	mkdir -p gtest && cd gtest && cmake $(GTESTDIR)

gtest/libgtest.a: gtest/Makefile
	$(MAKE) -C gtest CPPFLAGS="$(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" \
	  LDFLAGS="$(LDFLAGS)" gtest

$(ALL_TESTS): gtest/libgtest.a

proto/.depend: proto/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG proto/*.cc > proto/.depend1
	sed 's,\(.*\)\.o,proto/\1.o,' > proto/.depend < proto/.depend1
	rm proto/.depend1

merkletree/.depend: merkletree/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG merkletree/*.cc > merkletree/.depend1
	sed 's,\(.*\)\.o,merkletree/\1.o,' > merkletree/.depend \
					   < merkletree/.depend1
	rm merkletree/.depend1

log/.depend: log/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG log/*.cc > log/.depend1
	sed 's,\(.*\)\.o,log/\1.o,' > log/.depend < log/.depend1
	rm log/.depend1

util/.depend: util/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG util/*.cc > util/.depend1
	sed 's,\(.*\)\.o,util/\1.o,' > util/.depend < util/.depend1
	rm util/.depend1

client/.depend: client/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG client/*.cc > client/.depend1
	sed 's,\(.*\)\.o,client/\1.o,' > client/.depend < client/.depend1
	rm client/.depend1

server/.depend: server/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG server/*.cc > server/.depend1
	sed 's,\(.*\)\.o,server/\1.o,' > server/.depend < server/.depend1
	rm server/.depend1

### proto preprocessing
proto/%.pb.h proto/%.pb.cc: proto/%.proto
	protoc $^ --cpp_out=.

ifneq ($(MAKECMDGOALS),clean)
    include proto/.depend
    include merkletree/.depend
    include log/.depend
    include util/.depend
    include client/.depend
    include server/.depend
endif

unit_tests: proto_tests merkletree_tests log_tests util_tests

util_tests: util/json_wrapper_test

### util/ targets
util/libutil.a: util/util.o util/openssl_util.o util/testing.o
	rm -f $@
	ar -rcs $@ $^

util/json_wrapper_test: util/json_wrapper_test.o util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

### proto/ targets
proto/libproto.a: proto/ct.pb.o proto/serializer.o
	rm -f $@
	ar -rcs $@ $^

proto_tests: $(PROTO_TESTS)

proto/serializer_test: proto/serializer_test.o proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

### merkletree/ targets
merkletree/libmerkletree.a: merkletree/compact_merkle_tree.o \
                            merkletree/merkle_tree.o \
                            merkletree/merkle_tree_math.o \
                            merkletree/merkle_verifier.o \
                            merkletree/serial_hasher.o merkletree/tree_hasher.o
	rm -f $@
	ar -rcs $@ $^

merkletree_tests: $(MERKLETREE_TESTS)

merkletree/merkle_tree_large_test: merkletree/merkle_tree_large_test.o \
                                   merkletree/libmerkletree.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

merkletree/merkle_tree_test: merkletree/merkle_tree_test.o \
                             merkletree/libmerkletree.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

merkletree/serial_hasher_test: merkletree/serial_hasher_test.o \
                               merkletree/serial_hasher.o util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

merkletree/tree_hasher_test: merkletree/tree_hasher_test.o \
                             merkletree/serial_hasher.o \
                             merkletree/tree_hasher.o util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

### log/ targets
log/libcert.a: log/cert.o log/cert_checker.o log/cert_submission_handler.o \
               log/ct_extensions.o merkletree/serial_hasher.o
	rm -f $@
	ar -rcs $@ $^

log/libdatabase.a: log/file_storage.o log/filesystem_op.o log/file_db_cert.o \
                   log/sqlite_db_cert.o
	rm -f $@
	ar -rcs $@ $^

log/liblog.a: log/log_signer.o log/signer.o log/verifier.o log/frontend.o \
              log/frontend_signer.o log/log_verifier.o log/tree_signer_cert.o \
              log/log_lookup_cert.o
	rm -f $@
	ar -rcs $@ $^

log_tests: $(LOG_TESTS)

log/cert_test: log/cert_test.o log/cert.o log/ct_extensions.o util/libutil.a \
               merkletree/serial_hasher.o log/frontend.o proto/ct.pb.o \
               log/frontend_signer.o log/cert_submission_handler.o \
               log/log_signer.o log/signer.o log/verifier.o proto/serializer.o \
               log/cert_checker.o
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/cert_checker_test: log/cert_checker_test.o log/cert.o log/cert_checker.o \
                       log/ct_extensions.o util/libutil.a \
                       merkletree/serial_hasher.o log/frontend.o proto/ct.pb.o \
                       log/frontend_signer.o log/cert_submission_handler.o \
                       log/log_signer.o log/signer.o log/verifier.o \
                       proto/serializer.o log/cert_checker.o
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/cert_submission_handler_test: log/cert_submission_handler_test.o \
                                  log/libcert.a proto/libproto.a \
                                  util/libutil.a log/frontend.o \
                                  log/frontend_signer.o \
                                  log/log_signer.o log/signer.o log/verifier.o
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/ct_extensions_test: log/ct_extensions_test.o log/libcert.a util/libutil.a \
                        log/liblog.a proto/ct.pb.o \
                        log/cert_submission_handler.o proto/serializer.o \
                        log/cert_checker.o
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/database_large_test: log/database_large_test.o log/libdatabase.a \
                         log/log_signer.o log/signer.o log/verifier.o \
                         log/test_signer.o merkletree/libmerkletree.a \
                         proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/database_test: log/database_test.o log/libdatabase.a \
                   log/log_signer.o log/signer.o log/verifier.o \
                   log/test_signer.o merkletree/libmerkletree.a \
                   proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/file_storage_test: log/file_storage_test.o log/libdatabase.a \
                       proto/libproto.a util/libutil.a \
                       merkletree/libmerkletree.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/frontend_signer_test: log/frontend_signer_test.o \
                          log/frontend_signer.o \
                          log/log_signer.o log/signer.o log/verifier.o \
                          log/log_verifier.o log/test_signer.o log/libcert.a \
                          log/libdatabase.a merkletree/libmerkletree.a \
                          proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/frontend_test: log/frontend_test.o log/frontend.o \
                   log/frontend_signer.o \
                   log/log_signer.o log/signer.o log/verifier.o \
                   log/log_verifier.o log/test_signer.o \
                   log/libcert.a log/libdatabase.a merkletree/libmerkletree.a \
                   proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/log_lookup_test: log/log_lookup_test.o log/test_signer.o log/libdatabase.a \
                     log/liblog.a merkletree/libmerkletree.a proto/libproto.a \
                     util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/log_signer_test: log/log_signer_test.o log/log_signer.o log/signer.o \
                     log/verifier.o log/test_signer.o \
                     merkletree/libmerkletree.a proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/signer_verifier_test: log/signer_verifier_test.o log/log_signer.o \
                     log/signer.o log/verifier.o log/test_signer.o \
                     merkletree/libmerkletree.a proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/tree_signer_test: log/tree_signer_test.o log/log_signer.o log/signer.o \
                      log/verifier.o log/test_signer.o log/tree_signer_cert.o \
                      log/log_verifier.o \
                      log/libdatabase.a merkletree/libmerkletree.a \
                      proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/logged_certificate_test: log/logged_certificate_test.o proto/libproto.a \
                             util/libutil.a merkletree/libmerkletree.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

# client
client/ct: client/ct.o client/client.o client/log_client.o client/ssl_client.o \
           client/http_log_client.o $(LOCAL_LIBS)
	$(CXX) -o $@ $^ $(SYS_LIBS)

# server
server/ct-server: server/ct-server.o server/event.o $(LOCAL_LIBS)
	$(CXX) -o $@ $^ $(SYS_LIBS)

# FIXME(benl): unclear why a second copy of liblog is needed.
server/ct-rfc-server: server/ct-rfc-server.o $(LOCAL_LIBS)
	$(CXX) -o $@ $^ $(SYS_LIBS) log/liblog.a

server/blob-server: server/blob-server.o server/event.o \
                    server/sqlite_db_blob.o server/tree_signer_blob.o \
                    server/log_lookup_blob.o \
                    $(LOCAL_LIBS)
	$(CXX) -o $@ $^ $(SYS_LIBS)

test: all
	util/json_wrapper_test
	proto/serializer_test
	merkletree/serial_hasher_test
	merkletree/tree_hasher_test
	merkletree/merkle_tree_test
# Do not run merkletree/merkle_tree_large_test by default
	log/logged_certificate_test
	log/cert_test --test_certs_dir=test/testdata
	log/cert_checker_test --test_certs_dir=test/testdata
	log/cert_submission_handler_test --test_certs_dir=test/testdata
	log/ct_extensions_test --test_certs_dir=test/testdata
	log/file_storage_test
	log/database_test

=== src/python/Makefile ===
all: ct/proto/client_pb2.py ct/proto/ct_pb2.py

ct/proto/%_pb2.py: ct/proto/%.proto
	protoc $^ --python_out=.

ct/proto/ct_pb2.py: ../proto/ct.proto
	protoc --python_out=ct/proto --proto_path=../proto ../proto/ct.proto

test: all
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/sqlite_log_db_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/verify_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/merkle_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/pem_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/asn1/print_util_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/asn1/tag_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/asn1/types_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/asn1/oid_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/asn1/x509_time_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/cert_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/sqlite_cert_db_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/sqlite_connection_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/log_client_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/sqlite_temp_db_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/monitor_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/state_test.py

=== debian/changelog ===
certificate-transparency (20131206.1) unstable; urgency=low

  * Initial Release.

 -- Thijs Kinkhorst <thijs@debian.org>  Fri, 06 Dec 2013 11:19:02 +0100

## certificate-transparency 20140123.1

=== src/python/Makefile ===
--- 
+++ 
@@ -23,3 +23,5 @@
 	PYTHONPATH=$(PYTHONPATH):. ./ct/client/sqlite_temp_db_test.py
 	PYTHONPATH=$(PYTHONPATH):. ./ct/client/monitor_test.py
 	PYTHONPATH=$(PYTHONPATH):. ./ct/client/state_test.py
+# Tests using twisted trial instead of plain unittest.
+	PYTHONPATH=$(PYTHONPATH):. ./ct/client/async_log_client_test.py

=== debian/changelog ===
certificate-transparency (20140123.1) unstable; urgency=low

  * Initial Release.

 -- Thijs Kinkhorst <thijs@debian.org>  Fri, 06 Dec 2013 11:19:02 +0100

## certificate-transparency 20140130.1

=== src/Makefile ===
--- 
+++ 
@@ -69,14 +69,17 @@
             log/signer_verifier_test log/log_signer_test log/tree_signer_test \
             log/logged_certificate_test log/ct_extensions_test
 UTIL_TESTS = util/json_wrapper_test
-ALL_TESTS = $(PROTO_TESTS) $(MERKLETREE_TESTS) $(LOG_TESTS) $(UTIL_TESTS)
+MONITOR_TESTS = monitor/database_test
+ALL_TESTS = $(PROTO_TESTS) $(MERKLETREE_TESTS) $(LOG_TESTS) $(UTIL_TESTS) \
+	$(MONITOR_TESTS)
 
 all: unit_tests client/ct server/ct-server server/blob-server \
      server/ct-rfc-server
 
 .DELETE_ON_ERROR:
 .PHONY: clean all unit_tests test alltests benchmark clean \
-        proto_tests merkletree_tests log_tests client_tests
+        proto_tests merkletree_tests log_tests client_tests \
+	monitor_tests
 
 gtest/Makefile: $(GTESTDIR)
 	mkdir -p gtest && cd gtest && cmake $(GTESTDIR)
@@ -108,6 +111,11 @@
 	sed 's,\(.*\)\.o,util/\1.o,' > util/.depend < util/.depend1
 	rm util/.depend1
 
+monitor/.depend: monitor/*.cc */*.h
+	$(CXX) $(CXXFLAGS) -MM -MG monitor/*.cc > monitor/.depend1
+	sed 's,\(.*\)\.o,monitor/\1.o,' > monitor/.depend < monitor/.depend1
+	rm monitor/.depend1
+
 client/.depend: client/*.cc */*.h
 	$(CXX) $(CXXFLAGS) -MM -MG client/*.cc > client/.depend1
 	sed 's,\(.*\)\.o,client/\1.o,' > client/.depend < client/.depend1
@@ -127,11 +135,12 @@
     include merkletree/.depend
     include log/.depend
     include util/.depend
+    include monitor/.depend
     include client/.depend
     include server/.depend
 endif
 
-unit_tests: proto_tests merkletree_tests log_tests util_tests
+unit_tests: proto_tests merkletree_tests log_tests util_tests monitor_tests
 
 util_tests: util/json_wrapper_test
 
@@ -287,9 +296,19 @@
                              util/libutil.a merkletree/libmerkletree.a
 	$(CXX) -o $@ $^ $(SYS_LIBS)
 
+monitor_tests: $(MONITOR_TESTS)
+
+monitor/database_test: monitor/database_test.o monitor/database.o \
+                       monitor/sqlite_db.o util/libutil.a log/test_signer.o \
+                       merkletree/libmerkletree.a log/log_signer.o \
+                       log/signer.o log/verifier.o proto/libproto.a
+	$(CXX) -o $@ $^ $(SYS_LIBS)
+
 # client
 client/ct: client/ct.o client/client.o client/log_client.o client/ssl_client.o \
-           client/http_log_client.o $(LOCAL_LIBS)
+           client/http_log_client.o monitor/sqlite_db.o monitor/database.o \
+           monitor/monitor.o \
+           $(LOCAL_LIBS)
 	$(CXX) -o $@ $^ $(SYS_LIBS)
 
 # server
@@ -300,23 +319,3 @@
 server/ct-rfc-server: server/ct-rfc-server.o $(LOCAL_LIBS)
 	$(CXX) -o $@ $^ $(SYS_LIBS) log/liblog.a
 
-server/blob-server: server/blob-server.o server/event.o \
-                    server/sqlite_db_blob.o server/tree_signer_blob.o \
-                    server/log_lookup_blob.o \
-                    $(LOCAL_LIBS)
-	$(CXX) -o $@ $^ $(SYS_LIBS)
-
-test: all
-	util/json_wrapper_test
-	proto/serializer_test
-	merkletree/serial_hasher_test
-	merkletree/tree_hasher_test
-	merkletree/merkle_tree_test
-# Do not run merkletree/merkle_tree_large_test by default
-	log/logged_certificate_test
-	log/cert_test --test_certs_dir=test/testdata
-	log/cert_checker_test --test_certs_dir=test/testdata
-	log/cert_submission_handler_test --test_certs_dir=test/testdata
-	log/ct_extensions_test --test_certs_dir=test/testdata
-	log/file_storage_test
-	log/database_test

=== debian/changelog ===
certificate-transparency (20140130.1) UNRELEASED; urgency=low

  * Update git snapshot, change username, create logging dir.

 -- Thijs Kinkhorst <thijs@debian.org>  Thu, 30 Jan 2014 16:17:15 +0100

## certificate-transparency 20140506.1

=== src/Makefile ===
--- 
+++ 
@@ -29,6 +29,13 @@
   INCLUDE += -I $(OPENSSLDIR)/include
   SYS_LIBS += -L $(OPENSSLDIR) -L $(OPENSSLDIR)/lib -Wl,-rpath,$(OPENSSLDIR) \
           -Wl,-rpath,$(OPENSSLDIR)/lib
+endif
+
+# Allow non-system version of curl to be used.
+# Useful if it was built with a custom OpenSSL version.
+ifneq ($(CURLDIR),)
+  INCLUDE += -I $(CURLDIR)/include
+  SYS_LIBS += -L $(CURLDIR)/lib -Wl,-rpath,$(CURLDIR)/lib
 endif
 
 # Need cpp-netlib
@@ -312,10 +319,3 @@
 	$(CXX) -o $@ $^ $(SYS_LIBS)
 
 # server
-server/ct-server: server/ct-server.o server/event.o $(LOCAL_LIBS)
-	$(CXX) -o $@ $^ $(SYS_LIBS)
-
-# FIXME(benl): unclear why a second copy of liblog is needed.
-server/ct-rfc-server: server/ct-rfc-server.o $(LOCAL_LIBS)
-	$(CXX) -o $@ $^ $(SYS_LIBS) log/liblog.a
-

=== src/python/Makefile ===
--- 
+++ 
@@ -1,7 +1,8 @@
-all: ct/proto/client_pb2.py ct/proto/ct_pb2.py
+all: ct/proto/client_pb2.py ct/proto/ct_pb2.py ct/proto/tls_options_pb2.py \
+	ct/proto/test_message_pb2.py
 
 ct/proto/%_pb2.py: ct/proto/%.proto
-	protoc $^ --python_out=.
+	protoc $^ -I/usr/include/ -I. --python_out=.
 
 ct/proto/ct_pb2.py: ../proto/ct.proto
 	protoc --python_out=ct/proto --proto_path=../proto ../proto/ct.proto
@@ -23,5 +24,6 @@
 	PYTHONPATH=$(PYTHONPATH):. ./ct/client/sqlite_temp_db_test.py
 	PYTHONPATH=$(PYTHONPATH):. ./ct/client/monitor_test.py
 	PYTHONPATH=$(PYTHONPATH):. ./ct/client/state_test.py
+	PYTHONPATH=$(PYTHONPATH):. ./ct/client/tls_message_test.py
 # Tests using twisted trial instead of plain unittest.
 	PYTHONPATH=$(PYTHONPATH):. ./ct/client/async_log_client_test.py

=== debian/changelog ===
certificate-transparency (20140506.1) unstable; urgency=low

  * Update git snapshot. 

 -- Thijs Kinkhorst <thijs@debian.org>  Tue, 06 May 2014 09:49:04 +0200

certificate-transparency (20140502.1) unstable; urgency=low

  * Update git snapshot.

 -- Thijs Kinkhorst <thijs@debian.org>  Fri, 02 May 2014 16:45:49 +0200

=== debian/control ===
Source: certificate-transparency
Section: net
Priority: extra
Maintainer: Thijs Kinkhorst <thijs@debian.org>
Build-Depends: debhelper (>= 9),
 libgoogle-glog-dev (>= 0.3.0), libgflags-dev, libprotobuf-dev, libgtest-dev,
 libsqlite3-dev, libcurlpp-dev, libcppnetlib-dev, libjson0-dev,
 python-pyasn1, python-gflags, python-protobuf, protobuf-compiler,
 cmake
Standards-Version: 3.9.5
Homepage: http://www.certificate-transparency.org/
Vcs-Svn: https://svn.non-gnu.uvt.nl/uvt-dev/trunk/package/certificate-transparency

Package: ct-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Auditing for TLS certificates (server)
 Certificate Transparency provides an open framework for monitoring and
 auditing SSL certificates in nearly real time. Specifically, Certificate
 Transparency makes it possible to detect SSL certificates that have been
 mistakenly issued by a certificate authority or maliciously acquired from
 an otherwise unimpeachable certificate authority. It also makes it possible
 to identify certificate authorities that have gone rogue and are
 maliciously issuing certificates.
 .
 This package contains the log server.

Package: ct-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Auditing for TLS certificates (client)
 Certificate Transparency provides an open framework for monitoring and
 auditing SSL certificates in nearly real time. Specifically, Certificate
 Transparency makes it possible to detect SSL certificates that have been
 mistakenly issued by a certificate authority or maliciously acquired from
 an otherwise unimpeachable certificate authority. It also makes it possible
 to identify certificate authorities that have gone rogue and are
 maliciously issuing certificates.
 .
 This package contains the ct client.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ -D src

## certificate-transparency 20140506.2

=== debian/changelog ===
certificate-transparency (20140506.2) unstable; urgency=low

  * Add libcurl-openssl-dev to build-dependencies.

 -- Thijs Kinkhorst <thijs@debian.org>  Wed, 07 May 2014 20:05:41 +0200

certificate-transparency (20140130.1) unstable; urgency=low

  * Update git snapshot, change username, create logging dir.

 -- Thijs Kinkhorst <thijs@debian.org>  Thu, 30 Jan 2014 16:17:15 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: net
 Priority: extra
 Maintainer: Thijs Kinkhorst <thijs@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 9), libcurl4-openssl-dev,
  libgoogle-glog-dev (>= 0.3.0), libgflags-dev, libprotobuf-dev, libgtest-dev,
  libsqlite3-dev, libcurlpp-dev, libcppnetlib-dev, libjson0-dev,
  python-pyasn1, python-gflags, python-protobuf, protobuf-compiler,

## certificate-transparency 20140521.1

=== Makefile ===
CXXFLAG = -Wall -Werror -g -O3

# FIXME(benl): This breaks other installs and should be set locally if
# needed. It is not _technically_ their bug, it is _actually_ their
# bug. Commented out for now (as I can't build with it set).

INCLUDE = -I.
LOCAL_LIBS = log/libcert.a log/libdatabase.a log/liblog.a \
             merkletree/libmerkletree.a \
             proto/libproto.a util/libutil.a
GO_LIBS = go/merkletree/libmerkletree.syso  
SYS_LIBS = -lpthread -lgflags -lglog -lssl -lcrypto \
           -lsqlite3 -lprotobuf -lcurl -lcppnetlib-uri

PLATFORM = $(shell uname -s)
ifneq ($(PLATFORM), FreeBSD)
  SYS_LIBS += -lresolv
endif

ifeq ($(PLATFORM), Darwin)
  SYS_LIBS += -lboost_system-mt
else
  SYS_LIBS += -lboost_system
endif

# Need OpenSSL >= 1.0.0
ifneq ($(OPENSSLDIR),)
  INCLUDE += -I $(OPENSSLDIR)/include
  SYS_LIBS += -L $(OPENSSLDIR) -L $(OPENSSLDIR)/lib -Wl,-rpath,$(OPENSSLDIR) \
          -Wl,-rpath,$(OPENSSLDIR)/lib
endif

# Allow non-system version of curl to be used.
# Useful if it was built with a custom OpenSSL version.
ifneq ($(CURLDIR),)
  INCLUDE += -I $(CURLDIR)/include
  SYS_LIBS += -L $(CURLDIR)/lib -Wl,-rpath,$(CURLDIR)/lib
endif

# Need cpp-netlib
ifneq ($(CPPNETLIBDIR),)
  INCLUDE += -I $(CPPNETLIBDIR)
  SYS_LIBS += -L $(CPPNETLIBDIR)/libs/network/src \
              -Wl,-rpath,$(CPPNETLIBDIR)/libs/network/src
endif

# Json library location explicitly specified - link against that.
ifneq ($(JSONCLIBDIR),)
	INCLUDE += -I $(JSONCLIBDIR)/include
	SYS_LIBS += -L $(JSONCLIBDIR)/lib -Wl,-rpath,$(JSONCLIBDIR)/lib -ljson-c
else
	SYS_LIBS += -ljson
endif

# Need gtest
GTESTDIR ?= /usr/src/gtest
INCLUDE += -I $(GTESTDIR)/include

# Allow user-system overrides
INCLUDE += -I /usr/local/include
SYS_LIBS += -L /usr/local/lib

CXXFLAGS = $(INCLUDE) $(CXXFLAG) $(LOCAL_CXXFLAGS)

# File lists to simplify the rest of the Makefile

PROTO_TESTS = proto/serializer_test
MERKLETREE_TESTS = merkletree/merkle_tree_test \
                   merkletree/merkle_tree_large_test \
                   merkletree/serial_hasher_test merkletree/tree_hasher_test
LOG_TESTS = log/cert_test log/cert_checker_test \
            log/cert_submission_handler_test log/database_test \
            log/database_large_test log/file_storage_test \
            log/frontend_signer_test log/frontend_test log/log_lookup_test \
            log/signer_verifier_test log/log_signer_test log/tree_signer_test \
            log/logged_certificate_test log/ct_extensions_test
UTIL_TESTS = util/json_wrapper_test
MONITOR_TESTS = monitor/database_test
ALL_TESTS = $(PROTO_TESTS) $(MERKLETREE_TESTS) $(LOG_TESTS) $(UTIL_TESTS) \
	$(MONITOR_TESTS)

all: unit_tests client/ct server/ct-server server/blob-server \
     server/ct-rfc-server golibs

golibs: $(GO_LIBS)

.DELETE_ON_ERROR:
.PHONY: clean all unit_tests test alltests benchmark clean \
        proto_tests merkletree_tests log_tests client_tests \
	monitor_tests

gtest/Makefile: $(GTESTDIR)
	mkdir -p gtest && cd gtest && cmake $(GTESTDIR)

gtest/libgtest.a: gtest/Makefile
	$(MAKE) -C gtest CPPFLAGS="$(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" \
	  LDFLAGS="$(LDFLAGS)" gtest

$(ALL_TESTS): gtest/libgtest.a

proto/.depend: proto/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG proto/*.cc > proto/.depend1
	sed 's,\(.*\)\.o,proto/\1.o,' > proto/.depend < proto/.depend1
	rm proto/.depend1

merkletree/.depend: merkletree/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG merkletree/*.cc > merkletree/.depend1
	sed 's,\(.*\)\.o,merkletree/\1.o,' > merkletree/.depend \
					   < merkletree/.depend1
	rm merkletree/.depend1

log/.depend: log/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG log/*.cc > log/.depend1
	sed 's,\(.*\)\.o,log/\1.o,' > log/.depend < log/.depend1
	rm log/.depend1

util/.depend: util/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG util/*.cc > util/.depend1
	sed 's,\(.*\)\.o,util/\1.o,' > util/.depend < util/.depend1
	rm util/.depend1

monitor/.depend: monitor/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG monitor/*.cc > monitor/.depend1
	sed 's,\(.*\)\.o,monitor/\1.o,' > monitor/.depend < monitor/.depend1
	rm monitor/.depend1

client/.depend: client/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG client/*.cc > client/.depend1
	sed 's,\(.*\)\.o,client/\1.o,' > client/.depend < client/.depend1
	rm client/.depend1

server/.depend: server/*.cc */*.h
	$(CXX) $(CXXFLAGS) -MM -MG server/*.cc > server/.depend1
	sed 's,\(.*\)\.o,server/\1.o,' > server/.depend < server/.depend1
	rm server/.depend1

### proto preprocessing
proto/%.pb.h proto/%.pb.cc: proto/%.proto
	protoc $^ --cpp_out=.

ifneq ($(MAKECMDGOALS),clean)
    include proto/.depend
    include merkletree/.depend
    include log/.depend
    include util/.depend
    include monitor/.depend
    include client/.depend
    include server/.depend
endif

unit_tests: proto_tests merkletree_tests log_tests util_tests monitor_tests

util_tests: util/json_wrapper_test

### util/ targets
util/libutil.a: util/util.o util/openssl_util.o util/testing.o
	rm -f $@
	ar -rcs $@ $^

util/json_wrapper_test: util/json_wrapper_test.o util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

### proto/ targets
proto/libproto.a: proto/ct.pb.o proto/serializer.o
	rm -f $@
	ar -rcs $@ $^

proto_tests: $(PROTO_TESTS)

proto/serializer_test: proto/serializer_test.o proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

### merkletree/ targets
merkletree/libmerkletree.a: merkletree/compact_merkle_tree.o \
                            merkletree/merkle_tree.o \
                            merkletree/merkle_tree_math.o \
                            merkletree/merkle_verifier.o \
                            merkletree/serial_hasher.o merkletree/tree_hasher.o
	rm -f $@
	ar -rcs $@ $^

merkletree_tests: $(MERKLETREE_TESTS)

merkletree/merkle_tree_large_test: merkletree/merkle_tree_large_test.o \
                                   merkletree/libmerkletree.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

merkletree/merkle_tree_test: merkletree/merkle_tree_test.o \
                             merkletree/libmerkletree.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

merkletree/serial_hasher_test: merkletree/serial_hasher_test.o \
                               merkletree/serial_hasher.o util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

merkletree/tree_hasher_test: merkletree/tree_hasher_test.o \
                             merkletree/serial_hasher.o \
                             merkletree/tree_hasher.o util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

### log/ targets
log/libcert.a: log/cert.o log/cert_checker.o log/cert_submission_handler.o \
               log/ct_extensions.o merkletree/serial_hasher.o
	rm -f $@
	ar -rcs $@ $^

log/libdatabase.a: log/file_storage.o log/filesystem_op.o log/file_db_cert.o \
                   log/sqlite_db_cert.o
	rm -f $@
	ar -rcs $@ $^

log/liblog.a: log/log_signer.o log/signer.o log/verifier.o log/frontend.o \
              log/frontend_signer.o log/log_verifier.o log/tree_signer_cert.o \
              log/log_lookup_cert.o
	rm -f $@
	ar -rcs $@ $^

log_tests: $(LOG_TESTS)

log/cert_test: log/cert_test.o log/cert.o log/ct_extensions.o util/libutil.a \
               merkletree/serial_hasher.o log/frontend.o proto/ct.pb.o \
               log/frontend_signer.o log/cert_submission_handler.o \
               log/log_signer.o log/signer.o log/verifier.o proto/serializer.o \
               log/cert_checker.o
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/cert_checker_test: log/cert_checker_test.o log/cert.o log/cert_checker.o \
                       log/ct_extensions.o util/libutil.a \
                       merkletree/serial_hasher.o log/frontend.o proto/ct.pb.o \
                       log/frontend_signer.o log/cert_submission_handler.o \
                       log/log_signer.o log/signer.o log/verifier.o \
                       proto/serializer.o log/cert_checker.o
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/cert_submission_handler_test: log/cert_submission_handler_test.o \
                                  log/libcert.a proto/libproto.a \
                                  util/libutil.a log/frontend.o \
                                  log/frontend_signer.o \
                                  log/log_signer.o log/signer.o log/verifier.o
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/ct_extensions_test: log/ct_extensions_test.o log/libcert.a util/libutil.a \
                        log/liblog.a proto/ct.pb.o \
                        log/cert_submission_handler.o proto/serializer.o \
                        log/cert_checker.o
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/database_large_test: log/database_large_test.o log/libdatabase.a \
                         log/log_signer.o log/signer.o log/verifier.o \
                         log/test_signer.o merkletree/libmerkletree.a \
                         proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/database_test: log/database_test.o log/libdatabase.a \
                   log/log_signer.o log/signer.o log/verifier.o \
                   log/test_signer.o merkletree/libmerkletree.a \
                   proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/file_storage_test: log/file_storage_test.o log/libdatabase.a \
                       proto/libproto.a util/libutil.a \
                       merkletree/libmerkletree.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/frontend_signer_test: log/frontend_signer_test.o \
                          log/frontend_signer.o \
                          log/log_signer.o log/signer.o log/verifier.o \
                          log/log_verifier.o log/test_signer.o log/libcert.a \
                          log/libdatabase.a merkletree/libmerkletree.a \
                          proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/frontend_test: log/frontend_test.o log/frontend.o \
                   log/frontend_signer.o \
                   log/log_signer.o log/signer.o log/verifier.o \
                   log/log_verifier.o log/test_signer.o \
                   log/libcert.a log/libdatabase.a merkletree/libmerkletree.a \
                   proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/log_lookup_test: log/log_lookup_test.o log/test_signer.o log/libdatabase.a \
                     log/liblog.a merkletree/libmerkletree.a proto/libproto.a \
                     util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/log_signer_test: log/log_signer_test.o log/log_signer.o log/signer.o \
                     log/verifier.o log/test_signer.o \
                     merkletree/libmerkletree.a proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/signer_verifier_test: log/signer_verifier_test.o log/log_signer.o \
                     log/signer.o log/verifier.o log/test_signer.o \
                     merkletree/libmerkletree.a proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/tree_signer_test: log/tree_signer_test.o log/log_signer.o log/signer.o \
                      log/verifier.o log/test_signer.o log/tree_signer_cert.o \
                      log/log_verifier.o \
                      log/libdatabase.a merkletree/libmerkletree.a \
                      proto/libproto.a util/libutil.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

log/logged_certificate_test: log/logged_certificate_test.o proto/libproto.a \
                             util/libutil.a merkletree/libmerkletree.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

monitor_tests: $(MONITOR_TESTS)

monitor/database_test: monitor/database_test.o monitor/database.o \
                       monitor/sqlite_db.o util/libutil.a log/test_signer.o \
                       merkletree/libmerkletree.a log/log_signer.o \
                       log/signer.o log/verifier.o proto/libproto.a
	$(CXX) -o $@ $^ $(SYS_LIBS)

# client
client/ct: client/ct.o client/client.o client/log_client.o client/ssl_client.o \
           client/http_log_client.o monitor/sqlite_db.o monitor/database.o \
           monitor/monitor.o \
           $(LOCAL_LIBS)
	$(CXX) -o $@ $^ $(SYS_LIBS)

# server
server/ct-server: server/ct-server.o server/event.o $(LOCAL_LIBS)

=== doc/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
-VERSION=01
-PREV=00
+VERSION=03
+PREV=02
 XML=rfc6962-bis.xml
-NAME=draft-laurie-rfc6962-bis
+NAME=draft-ietf-trans-rfc6962-bis
 BASE=$(NAME)-$(VERSION)
 DIFF=$(NAME)-$(PREV)-$(VERSION)-diff.html

=== python/Makefile ===
all: ct/proto/client_pb2.py ct/proto/ct_pb2.py ct/proto/tls_options_pb2.py \
	ct/proto/test_message_pb2.py

ct/proto/%_pb2.py: ct/proto/%.proto
	protoc $^ -I/usr/include/ -I/usr/local/include -I. --python_out=.

ct/proto/ct_pb2.py: ../proto/ct.proto
	protoc --python_out=ct/proto --proto_path=../proto ../proto/ct.proto

test: all
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/sqlite_log_db_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/verify_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/merkle_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/pem_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/asn1/print_util_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/asn1/tag_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/asn1/types_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/asn1/oid_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/asn1/x509_time_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/crypto/cert_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/sqlite_cert_db_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/sqlite_connection_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/log_client_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/sqlite_temp_db_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/monitor_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/state_test.py
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/tls_message_test.py
# Tests using twisted trial instead of plain unittest.
	PYTHONPATH=$(PYTHONPATH):. ./ct/client/async_log_client_test.py

=== test/Makefile ===
test: apachectl mod_ssl.so
	cd .. && $(MAKE)
	OPENSSLDIR=$(OPENSSLDIR) ./sslconnect_test.sh

apachectl:
	{ which apachectl && ln -s `which apachectl` $@; } || \
	{ which apache2ctl && ln -s `which apache2ctl` $@; } || \
	{ test -x /usr/sbin/apachectl && ln -s /usr/sbin/apachectl $@; } || \
	{ test -x /usr/sbin/apache2ctl && ln -s /usr/sbin/apache2ctl $@; } || \
	{ echo "could not find $@"; false; }

mod_ssl.so:
	find \
	  /usr/lib/apache2/modules \
	  /usr/local/libexec/apache22 \
	  -name 'mod_ssl.so' | { read x; \
	    { test -n "$$x" && ln -s "$$x" $@; } || \
	    { echo "could not find $@"; false; } }

=== debian/changelog ===
certificate-transparency (20140521.1) unstable; urgency=low

  * Update git snapshot.
    - Stuff moved from src/ to toplevel.
    - Remove curlpp dependency. 
  * Allow to build in parallel.

 -- Thijs Kinkhorst <thijs@debian.org>  Wed, 21 May 2014 15:43:33 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Thijs Kinkhorst <thijs@debian.org>
 Build-Depends: debhelper (>= 9), libcurl4-openssl-dev,
  libgoogle-glog-dev (>= 0.3.0), libgflags-dev, libprotobuf-dev, libgtest-dev,
- libsqlite3-dev, libcurlpp-dev, libcppnetlib-dev, libjson0-dev,
+ libsqlite3-dev, libcppnetlib-dev, libjson0-dev,
  python-pyasn1, python-gflags, python-protobuf, protobuf-compiler,
  cmake
 Standards-Version: 3.9.5
